#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xos.h>
#include <X11/cursorfont.h>

static XColor colour[256];
static Colormap map=0;
Display *disp;
Window win;
XEvent rep;
GC gc;
XSizeHints hnts;
int scr;
XFontStruct *fnt;
Font fntid;
char puf[160];

main(argc,argv)
  int argc;
  char **argv;
{
     int lcs[256],i,j,luf;
     unsigned int rd[256], grn[256], blu[256];
     char *Xserver,*getenv();

	/* Let's get a connection to the X server. */
	if((disp = XOpenDisplay(Xserver)) == NULL){
		fprintf(stderr,"\nxwob: Cannot connect to X server %s\n",XDisplayName(Xserver));
		exit(-1);
	}
	fprintf(stderr,"\nxwob: Connected to X server %s\n",XDisplayName(Xserver));
	/* Get Screen Size */
	scr = DefaultScreen(disp);
	/* Load a font, then creat a label window. */
	fnt = XLoadQueryFont(disp,"9x15");
	fntid = fnt->fid;
	win = XCreateSimpleWindow(disp,RootWindow(disp,scr),0,0,65,30,2,
		BlackPixel(disp,scr),WhitePixel(disp,scr));
	
	/* Set up hints. */
	hnts.flags = PSize | PMinSize | PMaxSize;
	hnts.width = 65;
	hnts.height = 30;
	hnts.min_width = 65;
	hnts.min_height = 30;
	hnts.max_width = 65;
	hnts.max_height = 30;

	/* Set up properties of the window. */
	XSetStandardProperties(disp,win,"Wob","Wob",None,argv,argc,&hnts);
	XSelectInput(disp,win,ExposureMask | ButtonPressMask | EnterWindowMask);
	gc = XCreateGC(disp,win,0,0);
	XMapWindow(disp,win);

	/* Search for events. */
	while(1) {
	  XNextEvent(disp,&rep);
	  switch(rep.type){
	     case Expose :
		while(XCheckTypedEvent(disp,Expose,&rep));
		{
		  XSetFont(disp,gc,fntid);
		  XDrawImageString(disp,win,gc,3,21,"  Wob  ",7);
		}
        	/* Now let's Build a Colour Table. */
		if((map = XCreateColormap(disp,win,
			DefaultVisual(disp,DefaultScreen(disp)),AllocAll)) < 0){
	   	   fprintf(stderr,"\nxwob: Error allocating colour map\n");
	   	   exit(-1);
		}
	  	 
		/* First 6 places are set to white for labels and such. */
        	lcs[0] = 0;
        	lcs[1] = 1;
        	lcs[2] = 2;
        	lcs[3] = 3;
        	lcs[4] = 4;
        	lcs[5] = 5;
        	lcs[6] = 6;
        	rd[lcs[0]] = 0;
        	grn[lcs[0]] = 0;
        	blu[lcs[0]] = 0;
        	rd[lcs[1]] = 0;
        	grn[lcs[1]] = 0;
        	blu[lcs[1]] = 0;
        	rd[lcs[2]] = 255;
        	grn[lcs[2]] = 255;
        	blu[lcs[2]] = 255;
        	rd[lcs[3]] = 255;
        	grn[lcs[3]] = 255;
        	blu[lcs[3]] = 255;
        	rd[lcs[4]] = 255;
        	grn[lcs[4]] = 255;
        	blu[lcs[4]] = 255;
        	rd[lcs[5]] = 255;
        	grn[lcs[5]] = 255;
        	blu[lcs[5]] = 255;
        	rd[lcs[6]] = 255;
        	grn[lcs[6]] = 255;
        	blu[lcs[6]] = 255;
        	for (i=7; i<256; ++i) {
           	lcs[i] = i;
           	rd[lcs[i]] = i;
           	grn[lcs[i]] = 2*i;
           	blu[lcs[i]] = 4 * i;
        	};
		j = 0;
        	for (i=64; i<128; ++i) {
           	  blu[lcs[i]] = 255 - (4 * j);
		j++;
        	};
        	for (i=128; i<256; ++i) {
           	  blu[lcs[i]] = 0;
        	};
		j = 0;
        	for (i=128; i<213; ++i) {
           	  grn[lcs[i]] = 255 - (3 * j);
		j++;
        	};
        	for (i=213; i<256; ++i) {
           	  grn[lcs[i]] = 0;
        	};
		/* Now load X colour database.*/
		for( i=0; i<256; i++) {
	   	colour[i].pixel = (long)i;
	   	colour[i].red = (short)((int)rd[i] << 8);
	   	colour[i].green = (short)((int)grn[i] << 8);
	   	colour[i].blue = (short)((int)blu[i] << 8);
	   	colour[i].flags = DoRed | DoGreen | DoBlue;
		}
		/* Load colour table. */
		XStoreColors(disp,map,colour,256);
		XSetWindowColormap(disp,win,map);
		break;
	     case ButtonPress : /* Exit on button press. */
		if(rep.xbutton.window == win) {
		   printf("X error test -> ");
		   luf = 160;
		   XGetErrorText(disp,4,&puf[0],160);
		   printf(" %s\n",puf);
		   XFlush(disp);
		   XFreeGC(disp,gc);
		   XCloseDisplay(disp);
       		   exit(0);
		}
		else break;
	     default :
		break;
	  };
	};
}
